SystemOrganization addCategory: #'Pier-Gallery-Model'!
SystemOrganization addCategory: #'Pier-Gallery-Seaside'!
SystemOrganization addCategory: #'Pier-Gallery-Commands'!

!PRStructure methodsFor: '*pier-gallery-model-testing' stamp: 'damiencassou 11/18/2008 13:18'!
isGallery
	^ false! !

!PRStructure methodsFor: '*pier-gallery-model-testing' stamp: 'damiencassou 11/18/2008 13:18'!
isPicture
	^ false! !

!PRVisitor methodsFor: '*pier-gallery-model-visiting-structure' stamp: 'damiencassou 11/18/2008 13:27'!
visitGallery: aGallery
	self visitCase: aGallery! !

!PRVisitor methodsFor: '*pier-gallery-model-visiting-structure' stamp: 'damiencassou 11/18/2008 16:23'!
visitPicture: aPicture
	self visitCase: aPicture! !

Object subclass: #PGSqueakImageAssistant
	instanceVariableNames: 'file extent'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Gallery-Commands'!

!PGSqueakImageAssistant class methodsFor: 'actions' stamp: 'NR 2/4/2009 03:44'!
scaleMaxPicture: aMAFileModel extent: aPoint
	^ self new
		file: aMAFileModel;
		extent: aPoint;
		scaleMaxPicture! !

!PGSqueakImageAssistant class methodsFor: 'actions' stamp: 'damiencassou 11/19/2008 16:37'!
scalePicture: aMAFileModel extent: aPoint
	^ self new
		file: aMAFileModel;
		extent: aPoint;
		scalePicture! !

!PGSqueakImageAssistant class methodsFor: 'accessing' stamp: 'damiencassou 11/22/2008 18:35'!
streamClassFor: aBinaryStream ifNone: aBlock
	^ ImageReadWriter withAllSubclasses
		detect: [:subclass | subclass understandsImageFormat: aBinaryStream]
		ifNone: [
			aBinaryStream close.
			^ aBlock value]! !

!PGSqueakImageAssistant methodsFor: 'accessing' stamp: 'damiencassou 11/19/2008 16:37'!
extent: aPoint
	extent := aPoint! !

!PGSqueakImageAssistant methodsFor: 'accessing' stamp: 'damiencassou 11/19/2008 16:35'!
file: aFile
	file := aFile! !

!PGSqueakImageAssistant methodsFor: 'actions' stamp: 'NR 2/4/2009 03:45'!
scaleMaxPicture
	|bigForm original |
	original := ImageReadWriter formFromStream: file contents readStream.
	bigForm := original scaledToSize: extent.
	ByteArray streamContents: [:stream |
		self streamClass putForm: bigForm onStream: stream.
		^ MAExternalFileModel new
			filename: 'max_', file filename;
			contents: stream contents;
			yourself]! !

!PGSqueakImageAssistant methodsFor: 'actions' stamp: 'NR 2/4/2009 03:29'!
scalePicture
	|bigForm original smallForm crop h w d cropRect newExtent |
	original := ImageReadWriter formFromStream: file contents readStream.
	bigForm := original scaledToSize: 600@600.
	(bigForm width > bigForm height) ifTrue: [
		newExtent := (100 * (bigForm width)/(bigForm height))@100
	] ifFalse: [
		newExtent := 100@(100 * (bigForm height)/(bigForm width))
	].
	smallForm := bigForm scaledToSize: newExtent.
	h := smallForm height.
	w := smallForm width.
	(w > h) ifTrue: [
		d := ((w - h) / 2) asInteger.
		cropRect := (d@0 extent: extent).
	] ifFalse: [
		d := ((h - w) / 2) asInteger.
		cropRect := (0@d extent: extent).
	].
	crop := smallForm contentsOfArea: cropRect. 
	ByteArray streamContents: [:stream |
		self streamClass putForm: crop onStream: stream.
		^ MAExternalFileModel new
			filename: 'thumb_', file filename;
			contents: stream contents;
			yourself]! !

!PGSqueakImageAssistant methodsFor: 'accessing-dynamic' stamp: 'damiencassou 11/22/2008 18:35'!
streamClass
	^ self class streamClassFor: file readStream ifNone: [self error: 'image format not recognized'].! !

PRCommand subclass: #PGImportArchiveCommand
	instanceVariableNames: 'file'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Gallery-Commands'!

!PGImportArchiveCommand class methodsFor: 'descriptions' stamp: 'damiencassou 11/22/2008 18:18'!
descriptionFile
	^ PRFile descriptionFile 
		label: 'Zip archive';
		addCondition: [:file | file isApplication] labelled: 'Only zip archives are accepted';
		beRequired;
		yourself! !

!PGImportArchiveCommand class methodsFor: 'testing' stamp: 'damiencassou 11/22/2008 18:04'!
isAbstract
	^ false! !

!PGImportArchiveCommand class methodsFor: 'testing' stamp: 'damiencassou 11/22/2008 18:05'!
isValidIn: aContext
	^(super isValidIn: aContext)
		and: [aContext structure isGallery]! !

!PGImportArchiveCommand class methodsFor: 'accessing' stamp: 'damiencassou 11/22/2008 18:05'!
label
	^ 'Import pictures'! !

!PGImportArchiveCommand methodsFor: 'events' stamp: 'NR 2/4/2009 03:37'!
addPicture: archiveMember
	|fileModel picture|
	fileModel := MAExternalFileModel new
			filename: archiveMember fileName;
			contents: archiveMember contentStream contents;
			yourself.
	picture := PGPicture named: archiveMember fileName.
	picture file: fileModel.
	self structure addChild: picture! !

!PGImportArchiveCommand methodsFor: 'events' stamp: 'NR 2/4/2009 03:33'!
doExecute
	| zip |
	super doExecute.
	zip := ZipArchive new readFrom: self file contents readStream; yourself.
	zip members do: [:member | self possiblyAddFile: member].
	zip close! !

!PGImportArchiveCommand methodsFor: 'events' stamp: 'damiencassou 11/22/2008 18:21'!
doValidate
	super doValidate.
	(self file subtype = 'zip')
		ifFalse: [MAConditionError description: self description signal: 'Only zip files are accepted']! !

!PGImportArchiveCommand methodsFor: 'as yet unclassified' stamp: 'damiencassou 11/22/2008 18:18'!
file
	^ file! !

!PGImportArchiveCommand methodsFor: 'as yet unclassified' stamp: 'damiencassou 11/22/2008 18:20'!
file: aFile
	file := aFile! !

!PGImportArchiveCommand methodsFor: 'events' stamp: 'NR 2/4/2009 03:34'!
possiblyAddFile: archiveMember
	|memberStream|
	memberStream := archiveMember contentStream.
	(PGSqueakImageAssistant streamClassFor: memberStream ifNone: nil)
		ifNotNil: [self addPicture: archiveMember].
	memberStream close.
! !

PRCase subclass: #PGGallery
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Gallery-Model'!

PGGallery subclass: #PGGalleriesList
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Gallery-Model'!

!PGGalleriesList class methodsFor: 'as yet unclassified' stamp: 'NR 2/4/2009 04:20'!
canBeParentOf: aStructureClass
	^ aStructureClass includesBehavior: PGGallery ! !

!PGGalleriesList methodsFor: 'as yet unclassified' stamp: 'NR 2/4/2009 04:17'!
allPicturesIn: aContext
	^ (aContext enumeratorFor: self)
		select: [:child | child isGallery]! !

!PGGallery class methodsFor: 'testing' stamp: 'damiencassou 11/18/2008 13:40'!
canBeParentOf: aStructureClass
	^ aStructureClass includesBehavior: PGPicture ! !

!PGGallery class methodsFor: 'accessing-description' stamp: 'damiencassou 11/18/2008 13:24'!
descriptionDocument
	^ super descriptionDocument
		label: 'Description';
		yourself! !

!PGGallery class methodsFor: 'accessing-description' stamp: 'damiencassou 11/18/2008 13:31'!
descriptionTitle
	^ super descriptionTitle
		comment: 'Title of the gallery';
		yourself! !

!PGGallery class methodsFor: 'testing' stamp: 'damiencassou 11/18/2008 13:24'!
isAbstract
	^ false! !

!PGGallery methodsFor: 'visiting' stamp: 'damiencassou 11/18/2008 13:26'!
accept: aVisitor
	aVisitor visitGallery: self! !

!PGGallery methodsFor: 'accessing-dynamic' stamp: 'damiencassou 11/18/2008 13:20'!
allPicturesIn: aContext
	^ (aContext enumeratorFor: self)
		select: [:child | child isPicture]! !

!PGGallery methodsFor: 'testing' stamp: 'damiencassou 11/18/2008 13:18'!
isGallery
	^ true! !

!PGGallery methodsFor: 'testing' stamp: 'lr 12/17/2008 13:55'!
isValidView: aComponentClass in: aContext
	^ aComponentClass = self viewComponentClass or: [ (aComponentClass includesBehavior: PRDefaultView) not ]! !

!PGGallery methodsFor: '*pier-gallery-seaside' stamp: 'damiencassou 11/18/2008 13:46'!
viewComponentClass
	^ PGGalleryHtmlView ! !

PRCase subclass: #PGPicture
	instanceVariableNames: 'fileStructure thumbnail maxImage'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Gallery-Model'!

!PGPicture class methodsFor: 'testing' stamp: 'damiencassou 11/18/2008 13:39'!
canBeChildOf: aClass
	^ aClass includesBehavior: PGGallery ! !

!PGPicture class methodsFor: 'accessing-description' stamp: 'damiencassou 11/18/2008 13:33'!
descriptionDocument
	^ super descriptionDocument
		label: 'Description';
		yourself! !

!PGPicture class methodsFor: 'accessing-description' stamp: 'damiencassou 11/19/2008 13:39'!
descriptionFile
	^ PRFile descriptionFile
		addCondition: [:file | file isImage] labelled: 'Only pictures can be added to a gallery'! !

!PGPicture class methodsFor: 'accessing-description' stamp: 'damiencassou 11/18/2008 13:32'!
descriptionTitle
	^ super descriptionTitle 
		comment: 'Title of the picture';
		yourself! !

!PGPicture class methodsFor: 'testing' stamp: 'damiencassou 11/18/2008 13:41'!
isAbstract
	^ false! !

!PGPicture methodsFor: 'visiting' stamp: 'damiencassou 11/18/2008 13:28'!
accept: aVisitor
	aVisitor visitPicture: self! !

!PGPicture methodsFor: 'accessing-delegated' stamp: 'damiencassou 11/19/2008 16:51'!
extent
	^ 100@100! !

!PGPicture methodsFor: 'accessing-delegated' stamp: 'damiencassou 11/19/2008 13:36'!
file
	^ self fileStructure file! !

!PGPicture methodsFor: 'accessing-delegated' stamp: 'damiencassou 11/19/2008 13:36'!
file: aFile
	^ self fileStructure file: aFile! !

!PGPicture methodsFor: 'accessing' stamp: 'damiencassou 11/22/2008 20:12'!
fileStructure
	^ fileStructure ifNil: [fileStructure := PRFile named: '']! !

!PGPicture methodsFor: 'testing' stamp: 'damiencassou 11/18/2008 13:17'!
isPicture
	^ true! !

!PGPicture methodsFor: 'testing' stamp: 'lr 12/17/2008 13:57'!
isValidView: aComponentClass in: aContext
	^ aComponentClass = self viewComponentClass or: [ (aComponentClass includesBehavior: PRDefaultView) not ]! !

!PGPicture methodsFor: 'accessing-dynamic' stamp: 'NR 2/4/2009 03:49'!
maxImage
	^ maxImage ifNil: [maxImage := PGSqueakImageAssistant scaleMaxPicture: self file extent: 800@800]! !

!PGPicture methodsFor: 'accessing-dynamic' stamp: 'NR 2/4/2009 03:50'!
thumbnail
	^ thumbnail ifNil: [thumbnail := PGSqueakImageAssistant scalePicture: self file extent: self extent]! !

!PGPicture methodsFor: '*pier-gallery-seaside' stamp: 'damiencassou 11/18/2008 16:32'!
viewComponentClass
	^ PGPictureHtmlView ! !

PRDefaultView subclass: #PGHtmlView
	instanceVariableNames: 'gallery'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Gallery-Seaside'!

PGHtmlView subclass: #PGGalleryHtmlView
	instanceVariableNames: 'batcher'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Gallery-Seaside'!

PGGalleryHtmlView class
	instanceVariableNames: 'gallery'!

PGGalleryHtmlView class
	instanceVariableNames: 'gallery'!

!PGGalleryHtmlView class methodsFor: 'testing' stamp: 'damiencassou 11/18/2008 13:37'!
isAbstract
	^ false! !

!PGGalleryHtmlView methodsFor: 'as yet unclassified' stamp: 'NR 2/4/2009 02:41'!
batcher
	^ batcher ifNil: [batcher := WABatchedList new items: self pictures; batchSize: 21 ]! !

!PGGalleryHtmlView methodsFor: 'as yet unclassified' stamp: 'damiencassou 11/19/2008 15:36'!
children
	^ (Array with: self batcher), (self pictures gather: [:picture | picture componentsIn: self context])! !

!PGGalleryHtmlView methodsFor: 'accessing-dynamic' stamp: 'damiencassou 11/19/2008 13:46'!
pictures
	^ self gallery allPicturesIn: self context! !

!PGGalleryHtmlView methodsFor: 'rendering' stamp: 'damiencassou 11/19/2008 15:42'!
renderBatcherOn: html
	(self batcher maxPages = 1)
		ifFalse: [html render: self batcher]! !

!PGGalleryHtmlView methodsFor: 'rendering' stamp: 'damiencassou 11/19/2008 15:43'!
renderContentOn: html
	super renderContentOn: html.
	self renderPictures: self batcher batch on: html.
	self renderBatcherOn: html! !

!PGGalleryHtmlView methodsFor: 'rendering' stamp: 'nr 2/5/2009 15:05'!
renderPicture: aPicture on: html
	| galleryPicture |
	aPicture isGallery ifTrue: [
		galleryPicture := (aPicture allPicturesIn: self context) first.
		galleryPicture ifNotNil: [
			html div class: 'gallery-thumb'; with: [
				html div class: 'gallery-thumb-image'; with: [
					html anchor
					goto: (self context structure: aPicture);
					with: [ galleryPicture thumbnail renderImageOn: html ].
				].
				html div class: 'gallery-thumb-text'; with: [
					html text: aPicture name.
				]
			].
		]
	] ifFalse: [

	html anchor
		url: (aPicture maxImage urlOn: html); 
		rel: 'lightbox[set]';
		with: [aPicture thumbnail renderImageOn: html].
		
	self render: aPicture on: html.
	]! !

!PGGalleryHtmlView methodsFor: 'rendering' stamp: 'NR 2/4/2009 02:37'!
renderPictures: pictures on: html
	pictures do: [:picture |
		self renderPicture: picture on: html.
		html text: ' '.
		]! !

!PGHtmlView methodsFor: 'accessing-dynamic' stamp: 'damiencassou 11/18/2008 16:29'!
gallery
	^ gallery ifNil: [ gallery := self find: PGGallery]! !

PGHtmlView subclass: #PGPictureHtmlView
	instanceVariableNames: 'picture'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Gallery-Seaside'!

!PGPictureHtmlView methodsFor: 'accessing-dynamic' stamp: 'damiencassou 11/19/2008 13:55'!
picture
	^ picture ifNil: [picture := self find: PGPicture]! !

!PGPictureHtmlView methodsFor: 'rendering' stamp: 'NR 2/4/2009 01:34'!
renderContentOn: html
	super renderContentOn: html.
	"
	self render: self picture fileStructure on: html
	"
	self picture file renderImageOn: html! !
